﻿using System;
using System.IO;

namespace CMDSpacePirates
{
	public static class GameManager
    {
		public static int gunPrice = 10;
		public static int enginePrice = 10;
		public static int points = 25;

        static float enemySpawnInterval = 10 * 10000000;
        static float enemySpawnTimer;

		static string input;

		public static void Tick()
        {
			while (Console.KeyAvailable)
            {
				char currentKey = Console.ReadKey(false).KeyChar;

				if (currentKey == '\r' || currentKey == '\n')
                {
					GameConsole.UserInput(input);
					input = "";
				} else {
					input += currentKey;
				}
			}

			Console.Write(input);

            EnemySpawner();
        }

        public static void EnemySpawner()
        {
            enemySpawnTimer += Time.DeltaTime;
            if (enemySpawnTimer >= enemySpawnInterval)
            {
                enemySpawnTimer = 0;

                Vector pPos = Program.player.pos;
                Vector pDir = Program.player.dir;

                Vector ePos = Vector.Zero;
                Vector eDir = new Vector(1, 0);

                int r = Program.random.Next(20);

                switch (Program.random.Next(4))
                {
                    case 0: eDir = new Vector( 1, 0); break;
                    case 1: eDir = new Vector(-1, 0); break;
                    case 2: eDir = new Vector(0,  1); break;
                    case 3: eDir = new Vector(0, -1); break;
                    default: Console.WriteLine("Enemy direction fucked up yo"); break;
                }

                ePos = Render.WrapPosition(new Vector(pPos.x * r, pPos.y * r));
                //ePos = new Vector(ePos.x - eDir.x * (int)Vector.Distance(ePos, pPos), ePos.y - eDir.y * (int)Vector.Distance(ePos, pPos));

                //GameConsole.Write("Enemy spawned at " + ePos.x + " , " + ePos.y);

                new Enemy(ePos)
                {
                    dir = eDir
                };
            }
        }
	}
}
