﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CMDSpacePirates
{
	public class Player : Ship
    {
		public Player(Vector position) : base(position)
        {
			renderPriority = 2;
			pos = position;
			size = new Vector(7, 7);
			graphic =
			   (@"       " +
                @" /\_/\ " +
                @" \xex/ " +
                @" >gxg< " +
                @" /xex\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray();
        }

        public char[][] stopAnim = new char[][]
        {
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray(),
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray(),
        };
        public char[][] nAnim = new char[][]
        {
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray(),
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @" ^   ^ "
                ).ToCharArray()
        };
        public char[][] nwAnim = new char[][]
        {
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray(),
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx<«" +
                @" /xxx\ " +
                @" \/¯\/ " +
                @" ^   ^ "
                ).ToCharArray()
        };
        public char[][] neAnim = new char[][]
        {
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray(),
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @"»>xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @" ^   ^ "
                ).ToCharArray()
        };
        public char[][] sAnim = new char[][]
        {
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray(),
               (@" ¥   ¥ " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray()
        };
        public char[][] swAnim = new char[][]
        {
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray(),
               (@" ¥   ¥ " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx<«" +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray()
        };
        public char[][] seAnim = new char[][]
        {
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray(),
               (@" ¥   ¥ " +
                @" /\_/\ " +
                @" \xxx/ " +
                @"»>xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray()
        };
        public char[][] eAnim = new char[][]
        {
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray(),
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @"»>xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray()
        };
        public char[][] wAnim = new char[][]
        {
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx< " +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray(),
               (@"       " +
                @" /\_/\ " +
                @" \xxx/ " +
                @" >xxx<«" +
                @" /xxx\ " +
                @" \/¯\/ " +
                @"       "
                ).ToCharArray()
        };
    }
}
